
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rigattiere.h"
#include "list.h"

int conta(char* parola, FILE* fileVenduto, int dimMaxParola){
    int count=0;
    char *parolaTemp;

    parolaTemp = (char*)malloc(sizeof(char)*dimMaxParola);

    while( (fscanf(fileVenduto,"%s",parolaTemp))==1 ){
        if(strcmp(parola, parolaTemp)==0){
            count++;
        }
    }

    free(parolaTemp);
    return count;
}

list vendutoMolto(char* nomefileComprato, char* nomefileVenduto, int numMinOccorrenze){
    FILE *fileComprato, *fileVenduto;
    int dimMaxComprato, dimMaxVenduto, dimMaxParola;
    Oggetto ogg;

    list res;
    res=emptylist();

    fileComprato=fopen(nomefileComprato,"rt");
    if(fileComprato==NULL) exit(-1);
    fileVenduto=fopen(nomefileVenduto,"rt");
    if(fileVenduto==NULL) exit(-1);

    fscanf(fileComprato,"%d", &dimMaxComprato);
    fscanf(fileVenduto,"%d", &dimMaxVenduto);
    if(dimMaxVenduto > dimMaxComprato)
        dimMaxParola=dimMaxVenduto;
    else
        dimMaxParola=dimMaxComprato;

    ogg.nome = (char*)malloc(sizeof(char)*dimMaxParola);
    while( (fscanf(fileComprato, "%s", ogg.nome )) == 1 ) {
        ogg.dim = conta(ogg.nome, fileVenduto, dimMaxParola);
        if(ogg.dim>=numMinOccorrenze)
            res=cons(ogg,res);

        ogg.nome = (char*)malloc(sizeof(char)*dimMaxParola);
        rewind(fileVenduto);
        fscanf(fileVenduto, "%d", &dimMaxVenduto);
    }

    fclose(fileComprato);
    fclose(fileVenduto);

    return res;
}


list ordina(list disordinata){
    list start, l;
    int swapped;
    Oggetto temp;

    start=disordinata;
    temp.nome=(char*)malloc(sizeof(char)*30);
    
    // ITERATIVO NON OTTIMIZZATO
    do
    {
        swapped = 0;
        l=disordinata;
        while(disordinata!=NULL && disordinata->next!=NULL)
        {
            if(strcmp(disordinata->value.nome, disordinata->next->value.nome)==0)
            {
                disordinata->next=disordinata->next->next;
            }
            else if( (disordinata->value.dim > disordinata->next->value.dim)
                 || 
                    ( disordinata->value.dim == disordinata->next->value.dim &&
                    strcmp(disordinata->value.nome, disordinata->next->value.nome)>0 )
                )
            {
                swapped = 1;
                //swap
                temp.dim = disordinata->value.dim;
                strcpy(temp.nome, disordinata->value.nome);

                disordinata->value.dim = disordinata->next->value.dim;
                strcpy(disordinata->value.nome, disordinata->next->value.nome);

                disordinata->next->value.dim = temp.dim;
                strcpy(disordinata->next->value.nome, temp.nome);
            }
            disordinata=disordinata->next;
        }
        disordinata=start;
    }
    while (swapped);
    return start;
}

void nopari(list lista){
    item *prec=NULL;
    list start=lista;

    while(lista!=NULL){
        if(lista->value.dim%2 == 0){
            if(prec==NULL){
                start=lista->next;
                free(lista);
            }
            else{
                prec->next=lista->next;
                free(lista);
                lista=prec->next;
            }
        }
        else{
            prec=lista;
        lista=lista->next;
        }
    }
}

void soprasotto(FILE* fileComprato, FILE* fileOutput){
    char temp;
    char riga[121];
    int i, finefile, fineriga, num;

    fscanf(fileComprato, "%d\n", &num);
    
    // lettura riga
    finefile=0;
    fineriga=0;
    for( i=0; i<120 && !finefile && !fineriga; i++ ){
        finefile=(fscanf(fileComprato, "%c", &temp)!=1);
        if(!finefile){
            riga[i] = temp;
            fineriga = (temp=='\n');
            if(fineriga) riga[i]='\0';
        }
        else{
            riga[i]='\0';
        }
    }

    if(finefile){
        fprintf(fileOutput, "%s\n", riga);
        return;
    }
    else{
        soprasotto(fileComprato, fileOutput);
        fprintf(fileOutput, "%s\n", riga);
        return;
    }
}

